set ecn [lindex $argv 0]
set queue [lindex $argv 1]
set ml_rate [lindex $argv 2]
set ml_delay [lindex $argv 3]
set n_mulTFRC [lindex $argv 4]
set stoptime [lindex $argv 5]
set mode [lindex $argv 6] 
#mode=1 increase from 0 to 75mb; mode=2 decrease from 75mb to 0; mode=3 30 step increase
set starttime 0.0
set ref [lindex $argv 7]
puts "n:$n_mulTFRC queue:$queue rate:$ml_rate ecn:$ecn time:$stoptime"

proc stop {tracefile} {
    global ns
    $ns flush-trace
    close $tracefile
    exit
}

set ns [new Simulator]
#remove-all-packet-headers
#add-packet-header IP TCP TFRC
set tracefile [open "| ./throughput_TCP $ml_rate > ./output/mulTFRC_TCP_route_change.$queue.mod${mode}.ref${ref}.flows${n_mulTFRC}" w]
#$set tracefile [open ./trace.all  w]

set node_(r1) [$ns node]
set node_(r2) [$ns node]
set node3 [$ns node]
set node4 [$ns node]

Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}

$ns duplex-link $node_(r1) $node_(r2) [set ml_rate]Mb [set ml_delay]ms $queue
set link2 [$ns duplex-link $node3 $node4 [set ml_rate]Mb [set ml_delay]ms $queue]
$ns duplex-link $node_(r1) $node3 40Gb 0ms $queue
$ns duplex-link $node_(r2) $node4 40Gb 0ms $queue
source queueSize.tcl
#setQueueSize_load_change_scenario $ml_rate $queue 1024 $node_(r1) $node_(r2)
#Queue/DropTail set mean_pktsize_ 1040
setQueueSize3 $ml_rate $queue  $node_(r1) $node_(r2)
setQueueSize3 $ml_rate $queue  $node3 $node4
setQueueSize3 40000 DropTail  $node_(r1) $node3
setQueueSize3 40000 DropTail  $node_(r2) $node4
setQueueSize3 $ml_rate $queue  $node_(r1) $node_(r2)
$ns trace-queue $node_(r1) $node_(r2) $tracefile


#ns-random [clock seconds]
# Set up mulTFRC connection

Agent/TFRC set packetSize_ 1000
Agent/TFRC set n_mulTFRC_ $n_mulTFRC
Agent/TFRCSink set discount_ 1
Agent/TFRCSink set n_mulTFRC_ $n_mulTFRC
Agent/TFRCSink set algo_ 1
Agent/TFRC set refinement_ $ref
Agent/TFRC set df_ 0.95

    set node_s0 [$ns node]
    set node_k0 [$ns node]

    $ns duplex-link $node_s0 $node_(r1) 10Gb 0ms  $queue
    $ns duplex-link $node_k0 $node_(r2) 10Gb 0ms  $queue
setQueueSizeDra $ml_rate $queue $node_s0 $node_(r1)
setQueueSizeDra $ml_rate $queue $node_k0 $node_(r2)
    set tf0 [$ns create-connection TFRC $node_s0 TFRCSink $node_k0 0]

    set starttime 0.0
    $ns at $starttime "[set tf0] start"
    $ns at $stoptime "[set tf0] stop"

set n_TCP $n_mulTFRC

#if {$mode==3} {
#     set n_TCP [expr $n_mulTFRC*3]
#}

for {set i 0} {$i<$n_TCP} {incr i} {
    set node_(ts$i) [$ns node]
    set node_(tk$i) [$ns node]

    $ns duplex-link $node_(ts$i) $node3 20Gb 0ms  $queue
    $ns duplex-link $node_(tk$i) $node4 20Gb 0ms  $queue

    setQueueSizeDra $ml_rate $queue $node_(ts$i) $node3
    setQueueSizeDra $ml_rate $queue $node_(tk$i) $node4

    set tcp$i [$ns create-connection TCP/Sack1 $node_(ts$i) TCPSink/Sack1 $node_(tk$i) 0]
    [set tcp$i] set window_ 10000
    set ftp$i [[set tcp$i] attach-app FTP]
    $ns at 0 "[set ftp$i] start"
    $ns at $stoptime "[set ftp$i] stop"
}
#$ns cost $node_(r3) $node_(r4) 1
proc cost_link {cc} {
	global ns node3 node4
	$ns cost $node3 $node4 $cc
	$ns compute-routes
} 
if {$mode==1} {
        $ns at 0 "cost_link 1"
        $ns at 40.2 "cost_link 500"
}
if {$mode==2} {
        $ns at 0 "cost_link 500"
        $ns at 40 "cost_link 1" 
}

if {$mode==3} {
	$ns cost $node3 $node4 1
        $ns at 20 "cost_link 500"
        $ns at 50 "cost_link 1"
}




$ns at $stoptime "stop $tracefile"

$ns run
