set ecn [lindex $argv 0]
set queue [lindex $argv 1]
set ml_rate [lindex $argv 2]
set ml_delay [lindex $argv 3]
set n_mulTFRC [lindex $argv 4]
set stoptime [lindex $argv 5]
set mode [lindex $argv 6] 
#mode=1 increase from 0 to 75mb; mode=2 decrease from 75mb to 0; mode=3 30 step increase
set starttime 0.0
set ref [lindex $argv 7]
puts "n:$n_mulTFRC queue:$queue rate:$ml_rate ecn:$ecn time:$stoptime"

proc stop {tracefile} {
    global ns
    $ns flush-trace
    close $tracefile
    exit
}

set ns [new Simulator]
remove-all-packet-headers
add-packet-header IP TCP TFRC
set tracefile [open "| ./throughput $ml_rate > ./output/mulTFRC.$queue.mod${mode}.ref${ref}.flows${n_mulTFRC}" w]

set node_(r1) [$ns node]
set node_(r2) [$ns node]
Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}

$ns duplex-link $node_(r1) $node_(r2) [set ml_rate]Mb [set ml_delay]ms $queue
source queueSize.tcl
#setQueueSize_load_change_scenario $ml_rate $queue 1024 $node_(r1) $node_(r2)
Queue/DropTail set mean_pktsize_ 1040
#setQueueSizeDra $ml_rate $queue  $node_(r1) $node_(r2)
setQueueSize3 $ml_rate $queue  $node_(r1) $node_(r2)
$ns trace-queue $node_(r1) $node_(r2) $tracefile

#ns-random [clock seconds]
# Set up mulTFRC connection

Agent/TFRC set packetSize_ 1000
Agent/TFRC set n_mulTFRC_ $n_mulTFRC
Agent/TFRCSink set discount_ 1
Agent/TFRCSink set n_mulTFRC_ $n_mulTFRC
Agent/TFRCSink set algo_ 1
Agent/TFRC set refinement_ $ref
Agent/TFRC set df_ 0.95

    set node_s0 [$ns node]
    set node_k0 [$ns node]

    $ns duplex-link $node_s0 $node_(r1) 10Gb 1ms  $queue
    $ns duplex-link $node_k0 $node_(r2) 10Gb 1ms  $queue
setQueueSizeDraBWD $ml_rate $queue $node_s0 $node_(r1)
setQueueSizeDraBWD $ml_rate $queue $node_k0 $node_(r2)
    set tf0 [$ns create-connection TFRC $node_s0 TFRCSink $node_k0 0]

    set starttime 0.0
    $ns at $starttime "[set tf0] start"
    $ns at $stoptime "[set tf0] stop"



    set node_s1 [$ns node]
    set node_k1 [$ns node]

    $ns duplex-link $node_s1 $node_(r1) 1Gb 1ms  $queue
    $ns duplex-link $node_k1 $node_(r2) 1Gb 1ms  $queue

setQueueSizeDraBWD 1000 $queue $node_s1 $node_(r1)
setQueueSizeDraBWD 1000 $queue $node_k1 $node_(r2)
set udp [new Agent/UDP]
$ns attach-agent $node_s1 $udp
set null [new Agent/Null]
$ns attach-agent $node_k1 $null
$ns connect $udp $null

set cbr [new Application/Traffic/CBR]
$cbr attach-agent $udp
$cbr set type_ CBR
$cbr set packet_size_ 1000
$cbr set rate_ 10mb
$cbr set random_ false

if {$mode==1} {
    $ns at 9 "[set cbr] start"
    $ns at $stoptime "[set cbr] stop"
}
if {$mode==2} {
    $ns at 0 "[set cbr] start"
    $ns at 9 "[set cbr] stop"
}
proc traffic_increase {cbr_rate cbr} {
        global ns
        set cbr_rate [expr $cbr_rate+2.5]
        $cbr set rate_ [set cbr_rate]mb
        set now [$ns now]
        set now [expr $now+2]
        $ns at $now "traffic_increase $cbr_rate $cbr"
}

if {$mode==3} {
    $cbr set rate_ 1mb
    $ns at 9 "[set cbr] start"
    $ns at $stoptime "[set cbr] stop"
    $ns at 11 "traffic_increase 0 $cbr"
}




$ns at $stoptime "stop $tracefile"

$ns run
