set queue [lindex $argv 0]
set rate [lindex $argv 1]
set ecn [lindex $argv 2]
set nTFRC [lindex $argv 3]


proc stop {tracefile} {
    close $tracefile
    exit
}

set ns [new Simulator]
set tracefile [open all.full.tr w]
$ns trace-all $tracefile

set node_(r1) [$ns node]
set node_(r2) [$ns node]
Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}



set stoptime 50

$ns duplex-link $node_(r1) $node_(r2) [set rate]Mb 20ms $queue
source queueSize.tcl
setQueueSizeDragana $rate $queue $node_(r1) $node_(r2)
#$ns trace-queue $node_(r1) $node_(r2) $tracefile


#periodic loss 

set lossylink_ [$ns link $node_(r1) $node_(r2)]

set em [new ErrorModule Fid]
$lossylink_ errormodule $em
$em default pass

set emod [$lossylink_ errormodule]
set errmodel [new ErrorModel/List]
$errmodel unit pkt
$errmodel droplist { 50 150 250 350 450 550 650 750 850 
950 960 970 980 990 1000 1010 1020 1030 1040 
1050 1060 1070 1080 1090 1100 1110 1120 1130 1140 
1150 1160 1170 1180 1190 1200 1210 1220 1230 1240 
1250 1260 1270 
1470 1670 1870 2070 2270 
2470 2670 2870 3070 3270 
3470 3670 3870 4070 4270 
4470 4670 4870 5070 5270 
5470 5670 5870 6070 6270
6470 6670 6870 7070 
}
$emod insert $errmodel
$emod bind $errmodel 0





ns-random [clock seconds]
# Set up TCP connection
Agent/TFRC set packetSize_ 1000
 # n parameter mulTFRC
Agent/TFRC set n_mulTFRC_ $nTFRC
Agent/TFRCSink set discount_ 1
 # n parameter mulTFRC
Agent/TFRCSink set n_mulTFRC_ $nTFRC
Agent/TFRCSink set algo_ 1
#Agent/TFRCSink set history_ 0.2 
Agent/TFRC set df_ 0.95

    set node_s0 [$ns node]
    set node_k0 [$ns node]

    $ns duplex-link $node_s0 $node_(r1) 100Mb 2ms DropTail
    $ns duplex-link $node_k0 $node_(r2) 100Mb 1ms DropTail
    set tf0 [$ns create-connection TFRC $node_s0 TFRCSink $node_k0 0]
    set starttime 0.0
    $ns at $starttime "[set tf0] start"
    $ns at $stoptime "[set tf0] stop"


$ns at $stoptime "stop $tracefile"

$ns run
