set queue [lindex $argv 0]
set rate [lindex $argv 1]
set ecn [lindex $argv 2]
# n parameter mulTFRC
set nTFRC [lindex $argv 3]


proc stop {tracefile} {
    close $tracefile
    exit
}

set ns [new Simulator]
set tracefile [open all.full.tr w]
$ns trace-all $tracefile

set node_(r1) [$ns node]
set node_(r2) [$ns node]
Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}


set starttime 0.0
set stoptime 50

$ns duplex-link $node_(r1) $node_(r2) [set rate]Mb 20ms $queue
source queueSize.tcl
setQueueSizeDragana $rate $queue $node_(r1) $node_(r2)
#$ns trace-queue $node_(r1) $node_(r2) $tracefile


#periodic loss 

set lossylink_ [$ns link $node_(r1) $node_(r2)]

set em [new ErrorModule Fid]
$lossylink_ errormodule $em
$em default pass

set emod [$lossylink_ errormodule]
set errmodel [new ErrorModel/List]
$errmodel unit pkt
$errmodel droplist { 50 150 250 350 450 550 650 750 850 950 1050 1150 1250 1350 1450 1550 1650 1750 
1850 1860 1870 1880 1890 1900 1910 1920 1930 1940 
1950 1960 1970 1980 1990 2000 2010 2020 2030 2040 
2050 2060 2070 2080 2090 2100 2110 2120 2130 2140 
2150 2160 2170 2180 2190 2200 2210 2220 2230 2240 
2250 2260 2270 2280 2290 2300 2310 2320 2330 2340 
2350 2360 2370 2380 2390 2400 2410 2420 2430 2440 
2450 2650 2850 3050 3250 
3450 3650 3850 4050 4250 
4450 4650 4850 5050 5250 
5450 5650 5850 6050 6250 
6450 6650 6850 7050 7250 
7450 7650 7850 8050 8250 
8450 8650 8850 9050 9250 
9450 9650 9850 10050 10250 
10450 10650 10850 11050
}
$emod insert $errmodel
$emod bind $errmodel 0





ns-random [clock seconds]
# Set up TCP connection
Agent/TFRC set packetSize_ 1000
# n parameter mulTFRC
Agent/TFRC set n_mulTFRC_ $nTFRC	
Agent/TFRCSink set discount_ 1
# n parameter mulTFRC
Agent/TFRCSink set n_mulTFRC_ $nTFRC	
Agent/TFRCSink set algo_ 1
Agent/TFRCSink set refinement_ 1
Agent/TFRC set df_ 0.95

    set node_s0 [$ns node]
    set node_k0 [$ns node]

    $ns duplex-link $node_s0 $node_(r1) 100Mb 2ms DropTail
    $ns duplex-link $node_k0 $node_(r2) 100Mb 1ms DropTail
    set tf0 [$ns create-connection TFRC $node_s0 TFRCSink $node_k0 0]

    $ns at $starttime "[set tf0] start"
    $ns at $stoptime "[set tf0] stop"


$ns at $stoptime "stop $tracefile"

$ns run
