set flows [lindex $argv 0]
set queue [lindex $argv 1]
set rate [lindex $argv 2]
set ecn [lindex $argv 3]
set nTFRC [lindex $argv 4]
set ref [lindex $argv 5]

proc stop {tracefile} {
    close $tracefile
    exit
}

set ns [new Simulator]
remove-all-packet-headers
add-packet-header IP TCP TFRC
#set tracefile [open all.full.tr w]
set tracefile [open "| ./rate $rate 0 1 $nTFRC >> ./output/mulTFRC_TCP-$ref.$queue " w]

set node_(r1) [$ns node]
set node_(r2) [$ns node]
Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}

set stoptime 220

$ns duplex-link $node_(r1) $node_(r2) [set rate]Mb 20ms $queue
source queueSize.tcl
#Queue/DropTail set mean_pktsize_ 1000
#Queue/RED set mean_pktsize_ 1000
setQueueSize3 $rate $queue $node_(r1) $node_(r2)
$ns trace-queue $node_(r1) $node_(r2) $tracefile

ns-random [clock seconds]
# Set up TCP connection
Agent/TFRC set packetSize_ 1000
Agent/TFRC set n_mulTFRC_ $nTFRC
Agent/TFRCSink set discount_ 1
Agent/TFRCSink set n_mulTFRC_ $nTFRC
Agent/TFRCSink set algo_ 1
Agent/TFRC set refinement_ $ref
Agent/TFRC set df_ 0.95

    set node_s0 [$ns node]
    set node_k0 [$ns node]

    $ns duplex-link $node_s0 $node_(r1) 10Gb 2ms DropTail
    $ns duplex-link $node_k0 $node_(r2) 10Gb 1ms DropTail

    set tf0 [$ns create-connection TFRC $node_s0 TFRCSink $node_k0 0]

    set starttime 0.0
    $ns at $starttime "[set tf0] start"
    $ns at $stoptime "[set tf0] stop"

set incd [expr 2.0 / $flows]
#puts $incd
for {set i 0} {$i < $flows} {incr i} {
    set node_(ts$i) [$ns node]
    set node_(tk$i) [$ns node]
    $ns duplex-link $node_(ts$i) $node_(r1) 10Gb 2ms DropTail
    $ns duplex-link $node_(tk$i) $node_(r2) 10Gb [expr $i*$incd]ms DropTail
    set tcp$i [$ns create-connection TCP/Sack1 $node_(ts$i) TCPSink/Sack1 $node_(tk$i) 0]
    [set tcp$i] set overhead_ [expr (8*1040)/($rate*1024*1024)]
    [set tcp$i] set window_ 10000
    set ftp$i [[set tcp$i] attach-app FTP]
#puts  [expr $i*$incd]
    set sec [expr ($i)/10]
    set frac [expr $i%10]
    set starttime $sec.$frac

    $ns at $starttime "[set ftp$i] start"
    $ns at $stoptime "[set ftp$i] stop"
}

#    $ns at $starttime "[set tf0] start"
#    $ns at $stoptime "[set tf0] stop"

set randomflows 4
if {$randomflows > $flows} {
    set randomflows $flows
}

for {set i 0} {$i < $randomflows} {incr i} {
    set tcp2$i [$ns create-connection TCP/Sack1 $node_k0 TCPSink/Sack1 $node_s0 1]
    [set tcp2$i] set window_ 20

    set ftp2$i [[set tcp2$i] attach-app FTP]
    $ns at $i "[set ftp2$i] start"
    $ns at $stoptime "[set ftp2$i] stop"

}

$ns at $stoptime "stop $tracefile"

$ns run

