#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#define MAXCONNS 30
#define TFRM 1
#define TCP 2
#define CP 3

main(int argc, char **argv)
{

  int conns=0, i, j, cnum;
  int src, dst, size, dummy1, dummy4, pid;
  float ts, tsmax=0.0, psrc, pdst, tdiff;
  char type[10], flags[10];
  char line[80];
  char event;
  int connspace;
  float *srcs;
  float *dsts;
  unsigned long long *counts, *drop_each;
  int *types;
  int tcpconns=0;
  unsigned long long measured_conns=0;
  int lsrc, ldst, bw;
  double bwf=2.0;
  FILE *file;

//for the loss rate measure
unsigned long long sentAll=0;
unsigned long long dropAll=0;


  if (argc<5) {
    fprintf(stderr, "Usage: bwvt <avlen> <src> <dst> <filename> <n paramete>\n");
    exit(0);
  }
  //file = fopen(argv[4], "r");
  //if (file==NULL) {
  //  fprintf(stderr, "bwvt: failed to open file %s\n", argv[4]);
  //  exit(0);
  //}
  lsrc=atoi(argv[2]);
  ldst=atoi(argv[3]);
  bwf=atof(argv[1])*1000000.0/8.0;

double n_param=atof(argv[4]);
double rate=atof(argv[1]);

  srcs=(float*)malloc(sizeof(float)*MAXCONNS);
  dsts=(float*)malloc(sizeof(float)*MAXCONNS);
  counts=(unsigned long long*)malloc(sizeof(unsigned long long)*MAXCONNS);
  drop_each=(unsigned long long*)malloc(sizeof(unsigned long long)*MAXCONNS);
  types=(int*)malloc(sizeof(int)*MAXCONNS);
  connspace=MAXCONNS;
  //pass 1
//  while(feof(file)==0) {
//    fgets(line, 80, file);
 while(feof(stdin)==0) {
     fgets(line, 80, stdin);
    sscanf(line, "%c %f %d %d %s %d %s %d %f %f %d %d",
	   &event, &ts, &src, &dst, type, &size, flags, &dummy1, &psrc, 
	   &pdst, &dummy4, &pid);
    //only trace the packets on link lsrc -> ldst when they enter the queue
    //and only trace data packets in that direction
    if ((src!=lsrc)||(dst!=ldst)||(dummy1==1)) continue;

    //find the connection number
    cnum=-1;
    for(i=0;i<conns;i++) {
      if ((srcs[i]==psrc)&&(dsts[i]==pdst)) {
	cnum=i;
	break;
      }
    }
    if ((event=='+')&&(cnum==-1)) {
      fprintf(stderr, "new connection %d from %f to %f\n", conns, psrc, pdst);
      srcs[conns]=psrc;
      dsts[conns]=pdst;
      counts[conns]=0;
      drop_each[conns]=0;
      if (strcmp(type, "tcp")==0) {
	tcpconns++;
	types[conns]=TCP;
      } else if (strcmp(type, "tcpFriend")==0 || strcmp(type, "message")==0) {
	measured_conns++;
	types[conns]=TFRM;
      } else if (strcmp(type, "CP")==0 ) {
        measured_conns++;
        types[conns]=CP;
      }
      cnum=conns;
      conns++;
      if(conns==connspace) {
	srcs=(float *)realloc(srcs, sizeof(float)*(conns+MAXCONNS));
	dsts=(float *)realloc(dsts, sizeof(float)*(conns+MAXCONNS));
	counts=(unsigned long long *)realloc(counts, sizeof(unsigned long long)*(conns+MAXCONNS));
	drop_each=(unsigned long long *)realloc(drop_each, sizeof(unsigned long long)*(conns+MAXCONNS));
	types=(int *)realloc(types, sizeof(int)*(conns+MAXCONNS));
	connspace=conns+MAXCONNS;
      }
    }
    if (event=='r') {
      if (ts>30)
	{counts[cnum]+=size;
	sentAll++;
	}
        tsmax=ts;

    }
    if (event=='d') {
      if (ts>30)
        {dropAll++;
	drop_each[cnum]+=size;}
       
    }

  }
  fprintf(stderr, "writing output\n");

double tcpALL=0.0;
unsigned long long tcpSENT=0;
unsigned long long tcpDROP=0;
double measured_ALL=0.0;
unsigned long long  measured_SENT=0;
unsigned long long  measured_DROP=0;
int ismulTFRC=0;

  for(i=0;i<conns;i++) {
         if (types[i]==TCP) {
		tcpALL+=1.0* counts[i]*(tcpconns+n_param)/(bwf*(tsmax-30));
		tcpSENT=tcpSENT+counts[i];
		tcpDROP=tcpDROP+drop_each[i];
	 } else if (types[i]==TFRM || types[i]==CP) {
		measured_ALL+=1.0* counts[i]*(tcpconns+n_param)/n_param/(bwf*(tsmax-30));
                measured_SENT=measured_SENT+counts[i];
		measured_DROP+=drop_each[i];
		if (types[i]==TFRM )ismulTFRC=1;
	 }
   }
if (ismulTFRC==1)
printf("rate: %f n: %f tcp: %f %llu %llu mulTFRC: %f %llu %llu loss: %f %llu %llu",rate, n_param, tcpALL/tcpconns,tcpSENT,tcpDROP,measured_ALL,measured_SENT, measured_DROP, 1.0*dropAll/(sentAll+dropAll), sentAll, dropAll);		
else printf("rate: %f n: %f tcp: %f %llu CP: %f %llu loss: %f %llu %llu",rate, n_param, tcpALL/tcpconns,tcpSENT,measured_ALL,measured_SENT, 1.0*dropAll/(sentAll+dropAll), sentAll, dropAll);
  for(j=0;j<tcpconns;j++) {
    int max;
    int maxval;
    max=0;maxval=0;
    for(i=0;i<conns;i++) {
      if (types[i]==TCP)
	if (counts[i]>maxval) {
	  max=i;
	  maxval=counts[i];
	}
    }
    // The first number is the number of tcp connections, jittered
    // The second number is  ?/link bandwidth in bytes
    // bwf: link bandwidth in Bps
    // tsmax: ending time
    // conns: number of active connections of class 0
    // counts[max]:
    printf("tcp %f %llu %llu", counts[max]*(conns-1+n_param)/(bwf*(tsmax-30)), counts[max] ,drop_each[max]);
    counts[max]=0;
  }
  for(j=0;j<conns;j++) {
      if (types[j]==TFRM )
    printf("mulTFRC: %f %llu %llu", counts[j]*(tcpconns+n_param)/n_param/(bwf*(tsmax-30)), counts[j],drop_each[j]);
      if (types[j]==CP )
    printf("CP %f %llu %llu", counts[j]*(tcpconns+n_param)/(bwf*(tsmax-30)), counts[j],drop_each[j]);
  }
printf("\n");
}
