set ecn [lindex $argv 0]
set queue [lindex $argv 1]
set ml_rate [lindex $argv 2]
set ml_delay [lindex $argv 3] 
set n_mulTFRC [lindex $argv 4]
set stoptime [lindex $argv 5]
set starttime 0.0
set pm_rate [lindex $argv 6]
set packmime_count 9


if {$pm_rate==1.1} {
        ww=0.10
}
if {$pm_rate==7} {
        ww=0.45
}
if {$pm_rate==11.2} {
        ww=0.75
}


set ns [new Simulator]
remove-all-packet-headers
add-packet-header IP TCP TFRC
set tracefile [open "| ./rate_TCPs $ml_rate 0 1 $n_mulTFRC >> ./output/TCP_vs_TCP_PACKMIME_webtraffic.$queue.rate${ml_rate}_${ww}" w]
#set tracefile [open ./output//mulTFRC_PACKMIME_webtraffic.tr w]

set node_(r1) [$ns node]
set node_(r2) [$ns node]
Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}

$ns duplex-link $node_(r1) $node_(r2) [set ml_rate]Mb [set ml_delay]ms $queue
source queueSize.tcl
#setQueueSize_load_change_scenario $ml_rate $queue 1024 $node_(r1) $node_(r2)
setQueueSize3 $ml_rate $queue  $node_(r1) $node_(r2)
$ns trace-queue $node_(r1) $node_(r2) $tracefile
#$ns trace-queue $node_(r2) $node_(r1) $tracefile
#$ns trace-all $tracefile

for {set i 0} {$i < $n_mulTFRC} {incr i} {
    set node_(ts$i) [$ns node]
    set node_(tk$i) [$ns node]
    $ns duplex-link $node_(ts$i) $node_(r1) 10Gb 2ms DropTail
    $ns duplex-link $node_(tk$i) $node_(r2) 10Gb 1ms DropTail
    set tcp$i [$ns create-connection TCP/Sack1 $node_(ts$i) TCPSink/Sack1 $node_(tk$i) 0]
    [set tcp$i] set window_ 10000
    set ftp$i [[set tcp$i] attach-app FTP]

    set sec [expr ($i)/10]
    set frac [expr $i%10]
    set starttime $sec.$frac

    $ns at $starttime "[set ftp$i] start"
    $ns at $stoptime "[set ftp$i] stop"
}



for {set i 0} {$i < $n_mulTFRC} {incr i} {
    set node_(ts$i) [$ns node]
    set node_(tk$i) [$ns node]
    $ns duplex-link $node_(ts$i) $node_(r1) 10Gb 2ms DropTail
    $ns duplex-link $node_(tk$i) $node_(r2) 10Gb 1ms DropTail
    set tcp$i [$ns create-connection TCP/Sack1 $node_(ts$i) TCPSink/Sack1 $node_(tk$i) 0]
    [set tcp$i] set window_ 10000
    set ftp$i [[set tcp$i] attach-app FTP]

    set sec [expr ($i)/10]
    set frac [expr $i%10]
    set starttime $sec.$frac

    $ns at $starttime "[set ftp$i] start"
    $ns at $stoptime "[set ftp$i] stop"
}


###web traffic
set CLIENT 0
set SERVER 1

    set node_d1 [$ns DelayBox]
    set node_d2 [$ns DelayBox]
    $ns duplex-link $node_d2 $node_(r1) 10Gb 2ms  $queue
    $ns duplex-link $node_d1 $node_(r2) 10Gb 1ms  $queue
#	setQueueSizeDra 10000 DropTail $node_d2 $node_(r1)
#        setQueueSizeDra 10000 DropTail $node_d1 $node_(r2)

for {set i 0} {$i < $packmime_count} {incr i} { 
    set node_c($i) [$ns node]
    set node_s($i) [$ns node]
    $ns duplex-link $node_c($i) $node_d1 10Gb 1ms  $queue
    $ns duplex-link $node_s($i) $node_d2 10Gb 1ms  $queue
        setQueueSizeDra 10000 DropTail $node_c($i) $node_d1
        setQueueSizeDra 10000 DropTail $node_s($i) $node_d2


 Agent/TCP set window_ 10000
 Agent/TCP/FullTcp set segsize_ 1000

set pm($i) [new PackMimeHTTP]
        $pm($i) set-client $node_c($i)
        $pm($i) set-server $node_s($i)
set single_rate  [expr $pm_rate* $ml_rate/$packmime_count]
$pm($i) set-rate $single_rate

# create RNGs (appropriate RNG seeds are assigned automatically)
set flowRNG($i) [new RNG]
set reqsizeRNG($i) [new RNG]
set rspsizeRNG($i) [new RNG]

set flow_arrive($i) [new RandomVariable/PackMimeHTTPFlowArrive $single_rate]
set req_size($i) [new RandomVariable/PackMimeHTTPFileSize $single_rate $CLIENT]
set rsp_size($i) [new RandomVariable/PackMimeHTTPFileSize $single_rate $SERVER]

# assign RNGs to RandomVariables
$flow_arrive($i) use-rng $flowRNG($i)
$req_size($i) use-rng $reqsizeRNG($i)
$rsp_size($i) use-rng $rspsizeRNG($i)

# set PackMime variables
$pm($i) set-flow_arrive $flow_arrive($i)
$pm($i) set-req_size $req_size($i)
$pm($i) set-rsp_size $rsp_size($i)

}



set server_delay [new RandomVariable/Uniform]
    $server_delay set min_ 0;  # 0ms
    $server_delay set max_ 100; 

   for {set i 0} {$i < $packmime_count} {incr i} {
       $node_d2 add-rule [$node_c($i) id] [$node_s($i) id] $server_delay
    }
   for {set i 0} {$i < $packmime_count} {incr i} {
      $ns at 0.0 "$pm($i) start"
      $ns at $stoptime "$pm($i) stop"

   }







$ns at $stoptime "finish"
proc finish {} {
	global ns
	$ns flush-trace
	exit 0
}

puts "ns started"
$ns run

