set flows [lindex $argv 0]
set queue [lindex $argv 1]
set rate [lindex $argv 2]
set ecn [lindex $argv 3]
set nTFRC [lindex $argv 4]


proc stop {tracefile} {
    close $tracefile
    exit
}

set ns [new Simulator]
set tracefile [open all.full.tr w]

set node_(r1) [$ns node]
set node_(r2) [$ns node]
Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}

set stoptime 200

$ns duplex-link $node_(r1) $node_(r2) [set rate]Mb 20ms $queue
source queueSize.tcl
setQueueSize3 $rate $queue $node_(r1) $node_(r2) 
$ns trace-queue $node_(r1) $node_(r2) $tracefile

ns-random [clock seconds]
# Set up TCP connection
Agent/TFRC set packetSize_ 1000
Agent/TFRC set n_mulTFRC_ $nTFRC
Agent/TFRCSink set discount_ 1
Agent/TFRCSink set n_mulTFRC_ $nTFRC
Agent/TFRCSink set algo_ 1
Agent/TFRC set refinement_ 1 
Agent/TFRC set df_ 0.95

    set node_s0 [$ns node]
    set node_k0 [$ns node]

    $ns duplex-link $node_s0 $node_(r1) 10Gb 2ms DropTail
    $ns duplex-link $node_k0 $node_(r2) 10Gb 1ms DropTail
    set tf0 [$ns create-connection TFRC $node_s0 TFRCSink $node_k0 0]
    set starttime 0.0
    $ns at $starttime "[set tf0] start"
    $ns at $stoptime "[set tf0] stop"

for {set i 0} {$i < $flows} {incr i} {
    set node_(ts$i) [$ns node]
    set node_(tk$i) [$ns node]
    $ns duplex-link $node_(ts$i) $node_(r1) 10Gb 2ms DropTail
    $ns duplex-link $node_(tk$i) $node_(r2) 10Gb 1ms DropTail
    set tcp$i [$ns create-connection TCP/Sack1 $node_(ts$i) TCPSink/Sack1 $node_(tk$i) 0]
    [set tcp$i] set window_ 10000
    set ftp$i [[set tcp$i] attach-app FTP]

    set sec [expr ($i)/10]
    set frac [expr $i%10]
    set starttime $sec.$frac

    $ns at $starttime "[set ftp$i] start"
    $ns at $stoptime "[set ftp$i] stop"
}


$ns at $stoptime "stop $tracefile"

$ns run
