set flows [lindex $argv 0]
set queue [lindex $argv 1]
set rate [lindex $argv 2]
set ecn [lindex $argv 3]
set nTFRC [lindex $argv 4]


proc stop {tracefile} {
    close $tracefile
    exit
}

set ns [new Simulator]
set tracefile [open all.full.tr w]
$ns trace-all $tracefile
#set namfile [open all.full.nam w]
#$ns namtrace-all $namfile

set node_(r1) [$ns node]
set node_(r2) [$ns node]
Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}



set stoptime 180

$ns duplex-link $node_(r1) $node_(r2) [set rate]Mb 20ms $queue
source queueSize.tcl
setQueueSize $rate $queue $node_(r1) $node_(r2)
#$ns trace-queue $node_(r1) $node_(r2) $tracefile


#periodic loss

set loss_module [new ErrorModel/Periodic]
$loss_module set period_ 50
$ns lossmodel $loss_module $node_(r1) $node_(r2)




ns-random [clock seconds]
# Set up TCP connection
Agent/TFRC set packetSize_ 1000
Agent/TFRC set n_mulTFRC_ $nTFRC
Agent/TFRCSink set discount_ 1
Agent/TFRCSink set n_mulTFRC_ $nTFRC
Agent/TFRCSink set algo_ 1
Agent/TFRC set refinement_ 0 
Agent/TFRC set df_ 0.95

for {set i 0} {$i<$flows} {incr i} {
    set node_s($i) [$ns node]
    set node_k($i) [$ns node]

    $ns duplex-link $node_s($i) $node_(r1) 100Mb 2ms DropTail
    $ns duplex-link $node_k($i) $node_(r2) 100Mb 1ms DropTail
    set tf($i) [$ns create-connection TFRC $node_s($i) TFRCSink $node_k($i) 0]
    set starttime 0.0
    $ns at $starttime "[set tf($i)] start"
    $ns at $stoptime "[set tf($i)] stop"
}



$ns at $stoptime "stop $tracefile"

$ns run
