set ecn [lindex $argv 0]
set queue [lindex $argv 1]
set ml_rate [lindex $argv 2]
set ml_delay [lindex $argv 3]
set al_rate [lindex $argv 4]
set al_delay [lindex $argv 5]
set n_mulTFRC [lindex $argv 6]
set stoptime [lindex $argv 7]
set starttime 0.0
set ref  [lindex $argv 8]
puts "n:$n_mulTFRC queue:$queue rate:$ml_rate ecn:$ecn time:$stoptime"

proc stop {tracefile} {
    global ns
    $ns flush-trace
    close $tracefile
    exit
}

set ns [new Simulator]
remove-all-packet-headers
add-packet-header IP TCP TFRC
set tracefile [open "| ./rate $ml_rate 0 1 $n_mulTFRC >> ./output/mulTFRC.ref-$ref.$queue.noloss.$n_mulTFRC " w]

set node_(r1) [$ns node]
set node_(r2) [$ns node]
Queue/RED set gentle_ true
if {$ecn==1} {
  Queue/RED set setbit_ true
  Agent/TCP set ecn_ 1
}

Queue/DropTail  set mean_pktsize_ 1000
Queue/RED  set mean_pktsize_ 1000
$ns duplex-link $node_(r1) $node_(r2) [set ml_rate]Mb [set ml_delay]ms $queue
source queueSize.tcl
if {$ml_delay==30} {
setQueueSizeDra $ml_rate $queue $node_(r1) $node_(r2)
#setQueueSize3 $ml_rate $queue $node_(r1) $node_(r2)
}
if {$ml_delay==100} {
setQueueSizeDra_100ms $ml_rate $queue $node_(r1) $node_(r2)
}
$ns trace-queue $node_(r1) $node_(r2) $tracefile

#ns-random [clock seconds]
# Set up mulTFRC connection

Agent/TFRC set packetSize_ 1000
Agent/TFRC set n_mulTFRC_ $n_mulTFRC
Agent/TFRCSink set discount_ 1
Agent/TFRCSink set n_mulTFRC_ $n_mulTFRC
Agent/TFRCSink set algo_ 1
Agent/TFRC set refinement_ $ref
Agent/TFRC set df_ 0.95

    set node_s0 [$ns node]
    set node_k0 [$ns node]

    $ns duplex-link $node_s0 $node_(r1) [set al_rate]Gb [set al_delay]ms  $queue
    $ns duplex-link $node_k0 $node_(r2) [set al_rate]Gb [set al_delay]ms  $queue
setQueueSizeDra $al_rate $queue $node_s0 $node_(r1)
setQueueSizeDra $al_rate $queue $node_k0 $node_(r2)
    set tf0 [$ns create-connection TFRC $node_s0 TFRCSink $node_k0 0]

    set starttime 0.0
    $ns at $starttime "[set tf0] start"
    $ns at $stoptime "[set tf0] stop"






$ns at $stoptime "stop $tracefile"

$ns run
